#include "position.hpp"
#include "move.hpp"
#include "generateMoves.hpp"

#include "mate.h"

// l߃`FbN
// ԑłȂ
// l܂Ԃo[W
Move mateMoveInOddPlyReturnMove(Position& pos, int depth) {
	// ORߓ_

	// ׂĂ̍@ɂ
	for (MoveList<Check> ml(pos); !ml.end(); ++ml) {
		// 1蓮
		StateInfo state;
		pos.doMove(ml.move(), state);

		//std::cout << ml.move().toUSI() << std::endl;
		// l߃`FbN
		if (mateMoveInEvenPly(pos, depth - 1)) {
			// l݂_ŏI
			pos.undoMove(ml.move());
			return ml.move();
		}

		pos.undoMove(ml.move());
	}
	return Move::moveNone();
}

// l߃`FbN
// ԑłȂ
bool mateMoveInOddPly(Position& pos, int depth)
{
	// ORߓ_

	// ׂĂ̍@ɂ
	for (MoveList<Check> ml(pos); !ml.end(); ++ml) {
		// 1蓮
		StateInfo state;
		pos.doMove(ml.move(), state);

		//std::cout << ml.move().toUSI() << std::endl;
		// ̏ꍇ
		// l߃`FbN
		if (mateMoveInEvenPly(pos, depth - 1)) {
			// l݂_ŏI
			pos.undoMove(ml.move());
			return true;
		}

		pos.undoMove(ml.move());
	}
	return false;
}

// l߃`FbN
// ԑ肳Ă邱
bool mateMoveInEvenPly(Position& pos, int depth)
{
	// ANDߓ_

	// ׂĂEvasionɂ
	for (MoveList<Legal> ml(pos); !ml.end(); ++ml) {
		//std::cout << " " << ml.move().toUSI() << std::endl;
		// 1蓮
		StateInfo state;
		pos.doMove(ml.move(), state);

		// 肩ǂ
		if (pos.inCheck()) {
			// ̏ꍇ
			// l݂Ȃ_ŏI
			pos.undoMove(ml.move());
			return false;
		}

		if (depth == 4) {
			// 3l߂ǂ
			if (!mateMoveIn3Ply(pos)) {
				// 3l߂łȂꍇ
				// l݂Ȃ_ŏI
				pos.undoMove(ml.move());
				return false;
			}
		}
		else {
			// l߂ǂ
			if (!mateMoveInOddPly(pos, depth - 1)) {
				// l߂łȂꍇ
				// l݂Ȃ_ŏI
				pos.undoMove(ml.move());
				return false;
			}
		}

		pos.undoMove(ml.move());
	}
	return true;
}

// 3l߃`FbN
// ԑłȂ
bool mateMoveIn3Ply(Position& pos)
{
	// ORߓ_

	// ׂĂ̍@ɂ
	for (MoveList<Check> ml(pos); !ml.end(); ++ml) {
		// 1蓮
		StateInfo state;
		pos.doMove(ml.move(), state);

		//std::cout << ml.move().toUSI() << std::endl;
		// ̏ꍇ
		// 2l߃`FbN
		if (mateMoveIn2Ply(pos)) {
			// l݂_ŏI
			pos.undoMove(ml.move());
			return true;
		}

		pos.undoMove(ml.move());
	}
	return false;
}

// 2l߃`FbN
// ԑ肳Ă邱
bool mateMoveIn2Ply(Position& pos)
{
	// ANDߓ_

	// ׂĂEvasionɂ
	for (MoveList<Legal> ml(pos); !ml.end(); ++ml) {
		//std::cout << " " << ml.move().toUSI() << std::endl;
		// 1蓮
		StateInfo state;
		pos.doMove(ml.move(), state);

		// 肩ǂ
		if (pos.inCheck()) {
			// ̏ꍇ
			// l݂Ȃ_ŏI
			pos.undoMove(ml.move());
			return false;
		}

		// 1l߂ǂ
		if (pos.mateMoveIn1Ply() == Move::moveNone()) {
			// 1l߂łȂꍇ
			// l݂Ȃ_ŏI
			pos.undoMove(ml.move());
			return false;
		}

		pos.undoMove(ml.move());
	}
	return true;
}